/* RaWi-JS-Plugin: Pwstrength
*  JS-File:        pwstrength.js
*  CSS-File:       pwstrength.css */
(function() {
  // Constructor
  this.Pwstrength = function(element) {
    // Globale Plugin-Element-Referenz
    this.pwstrength = null;
    // Bar-Element
    this.strenghtbar = null;
    // Option defaults
    var defaults = {
      idpwelement: 'pwort1',
      idstrenghtbar: 'bar',
      barclassname: 'bar',
      pwminlength: 12,
      animtime: 300
    }
    // Option defaults einlesen
    if (arguments[0] && typeof arguments[0] === "object") {
      this.options = extendDefaults(defaults, arguments[0]);
    }
    // Vars
    this.pstrength = 0;
    this.aktstrength = this.pstrength;
    this.passwort = "";
    this.breite = 0;
    // Plugin-Elemente
    this.pwstrength = document.getElementById(this.options.idpwelement);
    this.strenghtbar = document.getElementById(this.options.idstrenghtbar);
    // EventListner
    this.pwstrength.addEventListener('keyup', this.handleKeyUp.bind(this));
  }
  // ---------------
  // Plugin-Methoden
  // ---------------
  // Breite von strenghtbar animieren
  Pwstrength.prototype.animate = function (barelement,breite) {
    var schritte = 100;
    var step = 20 / schritte;
    var aktstep = 0;
    var steptime = this.options.animtime / schritte;
    var aktbreite = 20 * this.aktstrength;
    var baranimation = setInterval(function(){ animate() }, steptime);
    function animate() {
      if (aktstep > schritte) {
        clearInterval(baranimation);
      } else {
        aktstep += 1;
        if (breite > aktbreite) {
          elembreite = aktbreite + parseFloat( aktstep * step ) + '%';
        } else {
          elembreite = (aktbreite - parseFloat( aktstep * step )) + '%';
        }
        barelement.style.width = elembreite;
      }
    }
  }
  // KeyUp-Handler
  Pwstrength.prototype.handleKeyUp = function (event) {
    // Passwort-Strength auf 0 setzen
    this.pstrength = 0;
    // Passwort aus dem Eingabefeld holen
    this.passwort = this.pwstrength.value;
    // Prfung Grobuchstaben
    if (this.passwort.match(/[A-ZÄÖÜ]{1,}/)) this.pstrength += 1;
    // Prfung Kleinbuchstaben
    if (this.passwort.match(/[a-zäöüß]{1,}/)) this.pstrength += 1;
    // Prfung Zahlen
    if (this.passwort.match(/\d{1,}/)) this.pstrength += 1;
    // Prfung Sonderzeichen
    if (this.passwort.match(/[!@#$%^&*?_~].*?[!@#$%^&*?_~]/)
       || this.passwort.match(/[!"@#\()+-.,;:§$%^&*?_~]/)) this.pstrength += 1;
    // Prfung Lnge
    if (this.passwort.length >= this.options.pwminlength) this.pstrength += 1;
    // Bar-Class bestimmen
    this.strenghtbar.className = this.options.barclassname + this.pstrength;
    // Bar animieren wenn aktstrength <> pstrength
    if (this.aktstrength != this.pstrength) {
      // Berechnung der Breite in Prozent
      this.breite = 20 * this.pstrength;
      // Bar animieren
      this.animate(this.strenghtbar,this.breite);
      // aktstrength aktualisieren
      this.aktstrength = this.pstrength;
    }
  }
  // ------------------------------
  // Option defaults implementieren
  // ------------------------------
  function extendDefaults(source, properties) {
    var property;
    for (property in properties) {
      if (properties.hasOwnProperty(property)) {
        source[property] = properties[property];
      }
    }
    return source;
  }
}());